function [res_classplsda] = classplsda(x,y,lv)

    // distributed under the CeCILL-C license
    // copyright INRA-IRSTEA 2013    
    
    [n,q]=size(x);
    
    qy=size(y,2);
    
    // pour éviter des valeurs nulles et rapprocher du centrage -> on prédit -1 ou 1
    y=2*(y - 0.5*ones(size(y,1),size(y,2)));
    
    // ajustement de la dim. max.
    lv2=min(lv,q);

    // application à la PLS
    rparam=x'*y;
    
    //normalisation des colonnes de rparam
    for i=1:qy;
       rparam(:,i)=rparam(:,i)/sqrt(rparam(:,i)'*rparam(:,i));
    end
    
    // calcul des loadings et métrique 
    loads = zeros(q,lv2);
    b = zeros(q,lv2);
    tscores=zeros(n,lv2);
    Xx = x'*x;
    tol = norm(size(Xx),'inf')*norm(Xx)*%eps;   //default tolerance value
    tol = tol*10;                               //customized tolerance value
    s = pinv(Xx,tol);s=(s+s')/2;                //so S is perfectly symmetrical! 

    for i1=1:lv2;
       if i1==1 
           POP=eye(q,q); 
       else
           POP=eye(q,q)- s*loads(:,1:i1-1)*loads(:,1:i1-1)';
       end;
       
       p_ally=POP'*Xx*POP'*rparam; // dimension (p x py)
       loads(:,i1)=mean(p_ally,'c');
       loads(:,i1)=loads(:,i1)/sqrt(loads(:,i1)'*s*loads(:,i1));
       
    end

    // sorties div
    //loads=div(loads);
    //s=div(s);
    
    res_classplsda.loadings=[];
    res_classplsda.loadings=loads;
    res_classplsda.m_metric=[];
    res_classplsda.m_metric=s;
        

    
endfunction
