function [cld] = conj2dis(c_in,nbcl);

 // function [cld] = conj2dis(cl,nbcl);
 // This function transforms a conjunctive vector into a disjunctive matrix
 // (nbcl columns)
 // 
 // Input:
 // ======
 // cl:                vector of P integers corresponding to classes
 // nbcl (optionnal):  used to force the dimension of cld
 //
 // Output:
 // =======
 // cld :              matrix of Booleans of dimensions P X ()number of classes)
 //   
 // Miscellaneous:
 // ==============
 // JM Roger (IRSTEA) and JC Boulet (INRA), France
 // Last update: 2012, March, 12
 // -----------------------------------------------

 [nargout,nargin]=argn(0);
 
 if isconj(c_in)=='T' then
 
   if nargin==1
      nbcl = max(c_in);
   end;

   nbech = size(c_in,1);

   cld = zeros(nbech,nbcl);
   for i=1:nbcl
     x=find(c_in==i);
     if ~isempty(x) then
        cld(x,i)=1;
     end;
   end;

 elseif isdisj(c_in)=='T' then 
   cld=c_in;
   
 else 
   error('input classes are neither conjunctive nor disjunctive') 

 end


endfunction
