function [data] = csv2div(filename)                                    

  //excel2saisir		- reads an excel file in the .CSV format (create a 3way character matrix).   
  //function [data] = excel2saisir(filename)                            
  //                                                                                       
  //Input arguments                                                                        
  //===============                                                                        
  //filename: name of an excel file saved in the .CSV format.                              
  //                                                                                       
  //Output argument:                                                                       
  //===============                                                                        
  //data: saisir file (with fields .d, .i , .v)
  //                                                                                       
  //This is a first step for decoding data coming from excel                               
  //                                                                                       
  ////Example:                                                                             
  ////========                                                                             
  //mywork=readexcel1('work1.csv',15);                                                     
  //                                                                                       
  //See also: excel2saisir, saisir2excel                                                   
  
                                                
  filename=convstr(filename,'u');
  aux=strindex(filename,'.CSV');
  if(isempty(aux))
     filename=[filename + '.CSV'];
  end

  a=mgetl(filename);
  a=strsubst(a,',','.');     // si délimiteur décimal ',' il est remplacé par '.' 
  a=strsubst(a,'""','');
                                    
  for i=2:size(a,1);                                                                  
     xline=a(i); 
     aux1=strindex(xline,';');    
     separation=strsplit(xline,aux1(1)-1);  // division of file into ident name and data  
     data.d(i-1,:)=evstr(separation(2))';                                                                 
     data.i(i-1)=stripblanks(separation(1)); 
  end                                                                                      
  
  xline=a(1);                                                                                 
  aux1=strindex(xline,';');
  vector=strsplit(xline,aux1);     // division of file into ident name and data  
  vector=strsubst(vector,';','');  // remove ;
  vector=stripblanks(vector);      // remove blanks
  data.v=vector(2:size(vector,1));  
  
  //div
  data=div(data);   


endfunction                                                                              
                                        

