function [ xsnv ] = snv(xi)

  //function[xsnv]=s_snv(xi)
  //
  // This function performs a standard normal variate correction
  // i.e. for each spectrum, mean=0 and std=1
  //
   //Inputs:
  //-------
  // x_cal:              calibration dataset
  //
  //
  //Outputs:
  //--------
  // xsnv.d:                 corrected input matrix
  // xsnv.v:                 variables identification
  // xsnv.i:                 samples identification
  //
  //
  // references: Barnes, 1989
  //
  // JC Boulet updated 2012,5,19th


  x=div(xi)


  [n,p]=size(x.d);


  x1=x.d- mean(x.d,'c')*ones(1,p);   //correction par ligne=spectre
  var=variance(x1,'c');
  x2=x1./(sqrt(var)*ones(1,p)); 

  // Output
  //-------
  xsnv.d=x2;
  xsnv.i=x.i;
  xsnv.v=x.v;
  
  // sortie Div:
  
  xsnv=div(xsnv);


endfunction

